#include <R.h>           // needed to use Rprintf()
#include <R_ext/Utils.h> // needed to allow user interrupts

#include <Rdefines.h>
#include <Rinternals.h>


// function that evaluatees the user supplied R function
SEXP r_fun_eval(SEXP fun, SEXP theta, SEXP fframe) {
  SEXP R_fcall;
  if(!isFunction(fun)) error("`fun' must be a function");
  if(!isEnvironment(fframe)) error("'fframe' must be an environment");
  PROTECT(R_fcall = lang2(fun, R_NilValue));
  SETCADR(R_fcall, theta);
  SEXP funval = eval(R_fcall, fframe);
  if (!isReal(funval)) error("`fun' must return a double");
  UNPROTECT(1);
  return funval;
}

SEXP mylapply(SEXP list, SEXP fn, SEXP rho)
{
   int i, n = length(list);
   SEXP R_fcall, ans;
   if(!isNewList(list)) error("'list' must be a list");
   if(!isFunction(fn)) error("'fn' must be a function");
   if(!isEnvironment(rho)) error("'rho' should be an environment");
   PROTECT(R_fcall = lang2(fn, R_NilValue));
   PROTECT(ans = allocVector(VECSXP, n));
   for(i = 0; i < n; i++) {
     SETCADR(R_fcall, VECTOR_ELT(list, i));
     SET_VECTOR_ELT(ans, i, eval(R_fcall, rho));
   }
   setAttrib(ans, R_NamesSymbol, getAttrib(list, R_NamesSymbol));
   UNPROTECT(2);
   return(ans);
}

